//
//  UIView+Addition.h
//  Addition
//
//  Created by 蔡成汉 on 15/11/20.
//  Copyright © 2015年 蔡成汉. All rights reserved.
//

#import <UIKit/UIKit.h>

@interface UIView (Addition)

/**
 Shortcut for frame.origin.y
 Sets frame.origin.y = top
 */
@property (nonatomic) CGFloat top;

/**
 Shortcut for frame.origin.x
 Sets frame.origin.x = left
 */
@property (nonatomic) CGFloat left;

/**
 Shortcut for frame.origin.y + frame.size.height
 Sets frame.origin.y = bottom - frame.size.height
 */
@property (nonatomic) CGFloat bottom;

/**
 Shortcut for frame.origin.x + frame.size.width
 Sets frame.origin.x = right - frame.size.width
 */
@property (nonatomic) CGFloat right;

/**
 Shortcut for frame.size.width
 Sets frame.size.width = width
 */
@property (nonatomic) CGFloat width;

/**
 Shortcut for frame.size.height
 Sets frame.size.height = height
 */
@property (nonatomic) CGFloat height;

/**
 Shortcut for center.x
 Sets center.x = centerX
 */
@property (nonatomic) CGFloat centerX;

/**
 Shortcut for center.y
 Sets center.y = centerY
 */
@property (nonatomic) CGFloat centerY;

/**
 Return the x coordinate on the screen
 */
@property (nonatomic, readonly) CGFloat ttScreenX;

/**
 Return the y coordinate on the screen
 */
@property (nonatomic, readonly) CGFloat ttScreenY;

/**
 Return the x coordinate on the screen, taking into account scroll views
 */
@property (nonatomic, readonly) CGFloat screenViewX;

/**
 Return the y coordinate on the screen, taking into account scroll views
 */
@property (nonatomic, readonly) CGFloat screenViewY;

/**
 Return the view frame on the screen, taking into account scroll views
 */
@property (nonatomic, readonly) CGRect screenFrame;

/**
 Shortcut for frame.origin
 */
@property (nonatomic) CGPoint origin;

/**
 Shortcut for frame.origin.x
 */
@property (nonatomic) CGFloat originX;

/**
 Shortcut for frame.origin.y
 */
@property (nonatomic) CGFloat originY;

/**
 Shortcut for frame.size
 */
@property (nonatomic) CGSize size;

/// 获取页面控制器，可能为空
@property (nonatomic, readonly) UIViewController *controller;

/// 页面点击
/// @param callBack 点击回调
- (void)addTapGesture:(void(^)(UITapGestureRecognizer *recognizer))callBack;

@end
